\version "2.19.82"
% automatically converted by musicxml2ly from Die_Himmel_erzählen_die_Ehre_Gottes_Schutz.mxl
% CPDL 46745 by James Gibb

revision = #"1.4"
variant = #'small  %% 16 pages, 2 systems per page, parenthesized cautionary accidentals
% variant = #'large  %% 8 pages, 3 systems per page, plain cautionary accidentals

% changelog:
% 1.4: internal restructuring:
%      - allow 16-page 2-systems-per-page layout
%      - preparation for Mensurstriche edition
%      - RehearsalMarks according to Bärenreiter edition BA 518 / BA 7978
% 1.3: more cautionary accidentals
% 1.2: corrected soprano II, bar 70; cautionary accidentals
% 1.1: formatting
% 1.0: initial version

\include "autoextenders.ily"
\include "center-lyrics-ignoring-punctuation.ily"
\include "lyric-syllable-magnetic-snap.ily"
\include "lyric-hyphen-text.ily"

\layout {
  \context {
    \Lyrics
    \override LyricExtender.minimum-length = #1
    \override LyricWord.after-line-breaking = #(lyric-word-compressor 0.5)
    \override LyricHyphen.minimum-distance = #0.
    \override LyricHyphen.minimum-length = #0.
  }
}

\include "notes.ly"

#(define (parenthesize-ambitus-notehead-callback callback)
   (define (parenthesize-stencil grob)
     (let* ((fn (ly:grob-default-font grob))
            (pclose (ly:font-get-glyph fn "accidentals.rightparen"))
            (popen (ly:font-get-glyph fn "accidentals.leftparen"))
            (subject (callback grob))
            ;; get position of stem
            (stem-pos (ly:grob-property grob 'stem-attachment))
            ;; remember old size
            (subject-dim-x (ly:stencil-extent subject X))
            (subject-dim-y (ly:stencil-extent subject Y)))

       ;; add parens
       (set! subject
             (ly:stencil-combine-at-edge
              (ly:stencil-combine-at-edge subject X RIGHT (ly:stencil-scale pclose 0.6 0.6) 0.2)
              X LEFT (ly:stencil-scale popen 0.6 0.6) 0.2))

       ;; adjust stem position
       ;(set! (ly:grob-property grob 'stem-attachment)
       ;      (cons (- (car stem-pos) 0.43) (cdr stem-pos)))

       ;; adjust size
       (ly:make-stencil
        (ly:stencil-expr subject)
        (interval-widen subject-dim-x 0.)
        subject-dim-y)))

   parenthesize-stencil)


date = #(strftime "%Y-%m-%d" (localtime (current-time)))

smallStaffSizeMm = #5.5
smallBaseFontsize = #10.
largeStaffSizeMm = #6.5
largeBaseFontsize = #11.5

#(define (mm->staffUnits height) (* (/ height 25.4) 72.27))
#(set-global-staff-size (mm->staffUnits (cond ((eq? variant 'small) smallStaffSizeMm)
                                          ((eq? variant 'large) largeStaffSizeMm))))
fontsizeBase = #(* (/ 72.27 72.) (cond ((eq? variant 'small) smallBaseFontsize)
                                   ((eq? variant 'large) largeBaseFontsize)))


\header {
  title =  \markup \override #'(font-name . "Alegreya SC Medium") \abs-fontsize #(* 1.66666 fontsizeBase) "Die Himmel erzählen die Ehre Gottes"
  composer =  \markup \abs-fontsize #fontsizeBase "Heinrich Schütz (1585 – 1672)"
  opus = \markup \abs-fontsize #fontsizeBase "Geistliche Chormusik (1648), Op. 11, Nr. 18 (SWV 386)"
  poet = \markup \abs-fontsize #fontsizeBase "Psalm 19, 2 – 7"
  pdftitle = "Heinrich Schütz: Die Himmel erzählen die Ehre Gottes (aus: „Geistliche Chormusik“ Op. 11, Nr. 18, SWV 386)"
  pdfauthor = "Engraving: Alexander Kobel"

  tagline = ##f
  copyright = \markup
  \with-color #grey
  \abs-fontsize #7.5 \column {
    \fill-line {
      "This edition may be freely distributed, duplicated, performed, and recorded."
      \concat { "Copyright © 2019 by the " \with-url #"https://www.cpdl.org/" "Choral Public Domain Library (www.cpdl.org)" "." }
    }
    \fill-line {
      \concat { "Engraving by " \with-url #"https://www.a-kobel.de/" "Alexander Kobel (www.a-kobel.de)" " using " \with-url #"https://www.lilypond.org" \concat { "LilyPond " #(lilypond-version) " (www.lilypond.org)" } "." }
      % \concat { "Engraved with " \with-url #"https://www.lilypond.org" \concat { "LilyPond " #(lilypond-version) " (www.lilypond.org)" } "." }
      % \strut
      \concat { "Revision " \revision " (" \date ")" }
    }
  }
}


#(define (defaultpaper-text-font-size)
   (module-ref
    (ly:output-def-scope (ly:parser-lookup '$defaultpaper))
    'text-font-size))

#(define (abs->font-size size)
   (magnification->font-size
    (/ size (defaultpaper-text-font-size))))


\paper {
  paper-width = 21\cm
  paper-height = 29.7\cm
  inner-margin = 1.5\cm
  outer-margin = 1.5\cm
  fonts = #
  (make-pango-font-tree
   "Alegreya"
   "Alegreya Sans"
   "DejaVu Sans Mono"
   (/ (* staff-height pt) 2.5)
   ;(/ 17 20)
   )

  two-sided = ##t
  oddHeaderMarkup = \markup \fill-line {
    " "
    \abs-fontsize #(* 1.25 fontsizeBase) \concat { \strut \on-the-fly #print-page-number-check-first \fromproperty #'page:page-number-string }
  }
  evenHeaderMarkup = \markup \fill-line {
    \abs-fontsize #(* 1.25 fontsizeBase) \concat { \strut \on-the-fly #print-page-number-check-first \fromproperty #'page:page-number-string }
    " "
  }

}

paperSmall = \paper {
  systems-per-page = #3
  page-count = #8
  top-margin = 0.75\cm
  bottom-margin = 0.55\cm
  top-system-spacing = #'((minimum-distance . 8) (padding . -10))
  last-bottom-spacing = #'((minimum-distance . 10) (padding . 4))
}

paperLarge = \paper {
  systems-per-page = #2
  page-count = #16
  top-margin = 1.5\cm
  bottom-margin = 1.5\cm
  top-system-spacing = #'((minimum-distance . 12) (padding . -10))
  last-bottom-spacing = #'((minimum-distance . 10) (padding . 4))
}

\layout {
  \context {
    \Score
    skipBars = ##t
    autoBeaming = ##f
  }
}

optbreak = {}

#(define (markAdditionalTextStencil text)
   (lambda (grob)
     (let* ((org-sten    (ly:text-interface::print grob))
            (layout      (ly:grob-layout grob))
            (props       (ly:grob-alist-chain grob (ly:output-def-lookup layout 'text-font-defaults)))
            (markup-sten (ly:text-interface::interpret-markup layout props
                           (markup #:abs-fontsize fontsizeBase #:italic text)))
            (pad         1)
            (comb-sten   (ly:stencil-stack org-sten X RIGHT markup-sten pad))
            (org-ext     (ly:stencil-extent org-sten X))
            (comb-ext    (ly:stencil-extent comb-sten X))
            )
       (ly:grob-set-property! grob 'self-alignment-X
         (- (* (/ (/ (interval-length org-ext) 2) (interval-length comb-ext)) 2.) 1))
       comb-sten)))

#(cond
  ((eq? variant 'small) (ly:parser-include-string "\\paperSmall\n"))
  ((eq? variant 'large) (ly:parser-include-string "\\paperLarge\n"))) 

marks = {
  \override Score.RehearsalMark.outside-staff-priority = #5000
  \set Score.markFormatter = #format-mark-circle-letters
  \tag #'DieHimmel {
    %% No need for a RehearsalMark at first beat...
    \once \override Score.RehearsalMark.self-alignment-X = #LEFT
    \mark \markup \abs-fontsize #fontsizeBase \italic "1. Die Himmel erzählen die Ehre Gottes"
    s1*12
    \mark \default s1*10
    \mark \default s1*6 s4 \mark \default s2. s1*5 s4
    \mark \default s2. s1*8 s2 \mark \default s2 s1*5
    \mark \default s1*6 \mark \default s2. %{ Bärenreiter (mis-)places this here \mark \default %} s4 s1*7 s4 \mark \default s2. s1*3 s4 \mark \default s2. s1*11 s4 \mark \default s2. s1*12
    \mark \default s1*10
  }
  \tag #'Doxologie {
    \once \override Score.RehearsalMark.stencil = #(markAdditionalTextStencil "2. Doxologie")
    \mark \default
    s1*8 \mark #14 s1*6
    \mark \default s1*13
  }
}  

marksBaerenreiter = {
  \override Score.RehearsalMark.outside-staff-priority = #5000
  \set Score.markFormatter = #format-mark-circle-alphabet
  %% Bärenreiter omits j instead of i
  \tag #'DieHimmel {
    \once \override Score.RehearsalMark.stencil = #(markAdditionalTextStencil "1. Die Himmel erzählen die Ehre Gottes")
    \mark \default
    s1*12
    \mark #2 s1*10
    \mark \default s1*6 s4 \mark \default s2. s1*5 s4
    \mark \default s2. s1*8 s2 \mark \default s2 s1*5
    \mark \default s1*6 s2. \mark \default s4 s1*7 s4 \mark \default s2. s1*3 s4 \mark #11 s2. s1*11 s4 \mark \default s2. s1*12
    \mark \default s1*10
  }
  \tag #'Doxologie {
    %% Bärenreiter starts counting at a again
    % \once \override Score.RehearsalMark.stencil = #(markAdditionalTextStencil "2. Doxologie")
    \mark \markup \concat { \strut\hspace #-1.5 \circle \bold "a" \hspace #2 \abs-fontsize #fontsizeBase \italic "2. Doxologie" }
    s1*8 \mark \markup \circle \bold "b" s1*6
    \mark \markup \circle \bold "c" s1*13
  }
}  

breaks = {
  \tag #'DieHimmel {
    s1*11 \noBreak s1
    \break
    s1*10
    s1*12 s4
    s2. s1*14
    \break
    s1*43
    \keepWithTag #variant { \tag #'large \break }
    s1*10
  }
  \tag #'Doxologie {
    \break
    s1*14
    s1*13
  }
}

who = {
  \override Voice.TextScript.font-name = #"Alegreya SC Medium"
  \override Voice.TextScript.font-size = #(abs->font-size fontsizeBase)
  \tag #'DieHimmel {
    s1*12^"Soli"
    s1*10^"omnes"
    s1*12^"Soli" s4
    s2.^"omnes" s1*14
    s1*43^"Soli"
    s1*10^"omnes"
  }
  \tag #'Doxologie {
    s1*14^"Soli"
    s1*13^"omnes"
  }
}

perStaff = {
  \time 2/2
  \key g \dorian
  \expandFullBarRests
  % \hide Staff.BarLine
  \newSpacingSection % after incipits
  \tag #'DieHimmel {
    % \set Score.proportionalNotationDuration = #(ly:make-moment 3/32)
    s1*12
    s1*10
    %\newSpacingSection
    s1*12 s4
    s2. s1*14
    %\newSpacingSection
    s1*43
    % s1*7 \newSpacingSection s1*12 \newSpacingSection s1*11 \newSpacingSection s1*13
    %\newSpacingSection
    s1*10
    % \once \undo \hide Staff.BarLine
    \bar "||"
  }
  \tag #'Doxologie {
    %\newSpacingSection
    s1*14
    %\newSpacingSection
    s1*13
    % \undo \hide Staff.BarLine
    \bar "|."
  }
}

cautionaryAsSuggestions =
#(define-music-function (m) (ly:music?)
   ;; Caveat: not usable for chords!
   (music-map
    (lambda (ev)
      (if (and (ly:music-property ev 'force-accidental #f)
               (ly:music-property ev 'cautionary #f))
          (make-music 'SequentialMusic
            'elements (list (make-music 'ContextSpeccedMusic 'context-type 'Bottom
                              'element (make-music 'PropertySet 'once #t 'value #t 'symbol 'suggestAccidentals))
                        (music-map (lambda (orig)
                                     (ly:music-set-property! orig 'cautionary #f)
                                     orig)
                          ev)))
          ev))
    m))

%#(set! toplevel-music-functions
%       (cons cautionaryAsSuggestions toplevel-music-functions))

incipitInit = {
  \once \override Score.RehearsalMark.self-alignment-X = #LEFT
  \once \override Score.RehearsalMark.break-align-symbols = #'(left-edge)
  \once \override Score.RehearsalMark.font-size = #(abs->font-size fontsizeBase)
  \once \override Score.RehearsalMark.font-name = #"Alegreya SC"
}

DieHimmel = \new ChoirStaff <<
  \new Devnull \marks
  % \new Devnull \marksBaerenreiter
  \new Devnull \breaks
  \new Staff <<
    \perStaff
    \set Staff.instrumentName = \markup \abs-fontsize #fontsizeBase "Soprano I"
    % \set Staff.shortInstrumentName = "S I"
    \incipit { \incipitInit \mark "Cantus." \clef "mensural-c1" \key g \dorian \time 4/4 r\breve d''2 s2 s1*9 s2 }
    \new Voice \with { \consists Ambitus_engraver \override NoteHead.stencil = ##f } { \voiceOne <c' f''>1*0 }
    \new Voice \who
    \context Voice = "sopI" \sopI
  >>
  \new Lyrics \lyricsto "sopI" \sopILyr

  \new Staff <<
    \perStaff
    \set Staff.instrumentName = \markup \abs-fontsize #fontsizeBase "Soprano II"
    % \set Staff.shortInstrumentName = "S II"
    \incipit { \incipitInit \mark "Sextus." \clef "mensural-c1" \key g \dorian \time 4/4 g'2 s2 s1*11 s2 }
    \new Voice \with { \consists Ambitus_engraver \omit NoteHead \override NoteColumn.ignore-collision = ##t } { \voiceOne <c' f''>1*0 }
    \context Voice = "sopII" \sopII
  >>
  \new Lyrics \lyricsto "sopII" \sopIILyr

  \new Staff <<
    \perStaff
    \set Staff.instrumentName = \markup \abs-fontsize #fontsizeBase "Alto"
    % \set Staff.shortInstrumentName = "A"
    \incipit { \incipitInit \mark "Altus." \clef "mensural-c3" \key g \dorian \time 4/4 r1 d'2 s2 s1*10 s2 }
    \new Voice \with { \consists Ambitus_engraver \omit AmbitusLine \omit NoteHead } { \voiceOne <d a'>1*0 }
    \new Voice \with { \consists Ambitus_engraver \omit NoteHead } { \voiceOne <f a'>1*0 }
    \new Voice \with { \consists Ambitus_engraver
                       \omit AmbitusLine
                       \override AmbitusNoteHead.stencil = #(parenthesize-ambitus-notehead-callback ly:note-head::print)
                       \omit NoteHead } { \voiceOne <f>1*0 }

    \context Voice = "alt" \alt
  >>
  \new Lyrics \lyricsto "alt" \altLyr

  \new Staff
  <<
    \clef "treble_8"
    \perStaff
    \set Staff.instrumentName = \markup \abs-fontsize #fontsizeBase "Tenor I"
    % \set Staff.shortInstrumentName = "T I"
    \incipit { \incipitInit \mark "Tenor." \clef "mensural-c4" \key g \dorian \time 4/4 r\longa*1/8 r\longa*1/8 c'\longa*1/8\rest \once \override MensuralStaff.BarLine.transparent = ##f \bar "|" d'2 }
    \new Voice \with { \consists Ambitus_engraver \omit NoteHead } { \voiceOne <c f'>1*0 }
    \context Voice = "tenI" \tenI
  >>
  \new Lyrics \lyricsto "tenI" \tenILyr

  \new Staff <<
    \clef "treble_8"
    \perStaff
    \set Staff.instrumentName = \markup \abs-fontsize #fontsizeBase "Tenor II"
    % \set Staff.shortInstrumentName = "T II"
    \incipit { \incipitInit \mark "Quintus." \clef "mensural-c4" \key g \dorian \time 4/4 r\longa*1/8 r\longa*1/8 c'\longa*1/8\rest \once \override MensuralStaff.BarLine.transparent = ##f \bar "|" g2 }
    \new Voice \with { \consists Ambitus_engraver \omit NoteHead } { \voiceOne <c f'>1*0 }
    \context Voice = "tenII" \tenII
  >>
  \new Lyrics \lyricsto "tenII" \tenIILyr

  \new Staff <<
    \clef "bass"
    \perStaff
    \set Staff.instrumentName = \markup \abs-fontsize #fontsizeBase "Bass"
    % \set Staff.shortInstrumentName = "B"
    \incipit { \incipitInit \mark "Bassus." \clef "mensural-f" \key g \dorian \time 4/4 r\longa*1/8 r\longa*1/8 b,\longa*1/8\rest \once \override MensuralStaff.BarLine.transparent = ##f \bar "|" g,2 }
    \new Voice \with { \consists Ambitus_engraver \omit NoteHead } { \voiceOne <f, bes>1*0 }
    \context Voice = "bas" \bas
  >>
  \new Lyrics \lyricsto "bas" \basLyr
>>

\layout {
  indent = 4.25\cm
  incipit-width = 2.25\cm
  indent = #(ly:mm (* 4.75 fontsizeBase))
  incipit-width = #(ly:mm (* 2.5 fontsizeBase))
  short-indent = 0\cm

  \context {
    \Score
    % proportionalNotationDuration = #(ly:make-moment 3/16)
    % proportionalNotationDuration = #(ly:make-moment 4/16)
    % \override SpacingSpanner.uniform-stretching = ##t
    % \override Score.RehearsalMark.self-alignment-X = #LEFT
  }
  \context {
    \Score
    \override BarNumber.extra-offset = #'(-0.5 . 0)
    \override BarNumber.font-size = #(abs->font-size fontsizeBase)
  }
  \context {
    \Staff
    \accidentalStyle choral-cautionary
    \override AccidentalCautionary.parenthesized = #(eq? variant 'large)
    \override AccidentalSuggestion.parenthesized = ##t
    \override AccidentalSuggestion.avoid-slur = #'around
  }
  \context {
    \Lyrics
    %\override LyricHyphen.whiteout-style = #'rounded-box
    %\override LyricHyphen.whiteout = #2.
    \override LyricText.font-size = #(abs->font-size fontsizeBase)
  }
  \context {
    \Voice
    \override Ambitus.space-alist = #'((clef extra-space . 1.5))
    %\slurUp
    %\omit Slur

    \override NoteHead.style = #'baroque
  }
  \context {
    \MensuralStaff
    \override BarLine.hair-thickness = #1
  }
}

\book {
  \bookOutputSuffix "g"
  
  \score {
    \DieHimmel
  }
  
  %{
  \score {
    \removeWithTag #'Doxologie \DieHimmel
  }

  \markup "BLABLABLA"

  \score {
    \removeWithTag #'DieHimmel \DieHimmel
    \layout {
      indent = 0\cm
      incipit-width = 0\cm
      \context {
        \Staff
        \remove Time_signature_engraver
        \remove Instrument_name_engraver
      }
    }
  }
  %}
}

\book {
  \bookOutputSuffix "a"

  \score {
    \transpose g a \DieHimmel
  }
}

DieHimmelMidi = <<
  \context Voice = "Soprano I"  \sopI  \addlyrics \sopILyr
  \context Voice = "Soprano II" \sopII \addlyrics \sopIILyr
  \context Voice = "Alto"       \alt   \addlyrics \altLyr
  \context Voice = "Tenor I"    \tenI  \addlyrics \tenILyr
  \context Voice = "Tenor II"   \tenII \addlyrics \tenIILyr
  \context Voice = "Bass"       \bas   \addlyrics \basLyr
>>


\book {
  \bookOutputName "himmel-g"
  \score {
    \DieHimmelMidi
    \midi {\tempo 4 = 132 }
  }
}

\book {
  \bookOutputName "himmel-a"
  \score {
    \transpose g a \DieHimmelMidi
    \midi {\tempo 4 = 132 }
  }
}
